<?php
/**
 * Created by PhpStorm.
 * User: pc
 * Date: 2021/4/12
 * Time: 13:16
 */

namespace app\admin\controller;
use think\facade\Db;
use think\facade\View;
use app\admin\model\Conflist;
class File extends Common
{

    /**
     * 显示资源列表
     *
     * @return \think\Response
     */
    public function index()
    {



      $currdir= input('path')?input('path'):app()->getRootPath().'template';

        $currdir=iconv('UTF-8','GB2312',$currdir);

        if ($currdir){
            if (file_exists($currdir)){
                if (stripos($currdir,$currdir)===0 && stripos($currdir,$currdir.'..')===false){
                    chdir($currdir);
                }
            }
        }



        if(empty($currdir) || !file_exists($currdir)){

            return json(['code'=>0,'msg'=>'templateq前端文件不存在']);
        }
        $rootdir=getcwd();
        $count=explode('/',$rootdir);

        if (count($count)<0){
            return json(['code'=>0,'msg'=>'已是最顶级目录']);
        }
        $dir=opendir($rootdir);

        $data=[];
        $num=[];
        $num['dir']=0;
        $num['file']=0;
        while ($filename=readdir($dir)){
            if ($filename!="." && $filename!=".."){

                if (is_dir($filename)){
                    $arr['icon']="icon-24gf-folderPlus";
                    $arr['flag']=1;
                    $num['dir']++;
                }else{
                    $arr['icon']=$this->seticon($filename);
                    $arr['flag']=0;
                    $num['file']++;
                }
                $arr['currdir']=iconv('GB2312','UTF-8',getcwd()."/".$filename);

                $arr['name']=$filename;

                $arr['size']=filesize($filename);
                $arr['ctime']=filectime($filename);
                $arr['mtime']=filemtime($filename);

                $data[]=$arr;
            }
        }

        array_multisort(array_column($data,'flag'),SORT_DESC,$data);
        $curr=input('page');
        $currpage=$this->page_array($data,10,$curr);


        View::assign([
            'curdir'=>$rootdir,
            'dirs'=>$currpage['data'],
            'page'=>$currpage['page'],
            'num'=>$num
        ]);
        return view();
    }

    /**
     * @param $filename
     * @return string
     */
    public function seticon($filename){
        $exc=strtoupper(substr($filename,strrpos($filename,".")));
        $icon='';
        switch ($exc){
            case ".HTML":
                $icon="icon-html1";
                break;
            case ".PHP":
                $icon="icon-suffix-php";
                break;
            case ".JS":
                $icon="icon-js1";
                break;
            case ".BMP":
                $icon="icon-picture";
                break;
            case ".PNG":
                $icon="icon-picture";
                break;
            case ".JPEG":
                $icon="icon-picture";
                break;
            case ".GIF":
                $icon="icon-picture";
                break;
            case ".CSS":
                $icon="icon-css1";
                break;
            case ".JPG":
                $icon="icon-picture";
                break;
            case ".JSON":
                $icon="icon-js1";
                break;
            case ".DOCX":
                $icon="icon-DOCX";
                break;
            case ".DOC":
                $icon="icon-DOCX";
                break;
            case ".MP4":
                $icon="icon-shipin";
                break;
            case ".FLV":
                $icon="icon-shipin";
                break;
            case ".SWF":
                $icon="icon-shipin";
                break;
            case ".RAR":
                $icon="icon-yasuobao";
                break;
            case ".ZIP":
                $icon="icon-yasuobao";
                break;
            case ".ARJ":
                $icon="icon-yasuobao";
                break;
            default :
                $icon='icon-file';
        }
        return $icon;
    }

    private function page_array($arr, $page=10, $curr){
        $total=ceil(count($arr)/$page);
        if($curr<=0) $curr=1;
        if($curr>$total) $curr=$total;
        $data=array_slice($arr,($curr-1)*$page,$page);
        return [
            'data'=>$data,
            'page'=>[
                'count'=>count($arr),
                'limit'=>$page,
                'curr'=>$curr
            ]
        ];

    }


    public function renames(){
        if(request()->isAjax()){
            $file=iconv("UTF-8","GB2312",urldecode(input('file')));
            $filename=input('filename');
            $newfile=iconv("UTF-8","GB2312",dirname($file).'/'.$filename);
            if(file_exists($newfile)){
                return json(['code'=>0,'msg'=>'文件已存在（重名）']);
            }
            @rename($file,$newfile);
            return json(['code'=>1,'msg'=>'重命名成功']);
        }
    }

    //文件编辑

    /**
     * @return \think\response\View
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     */
    public function edit(){
        $cata=input('file');

        $file=iconv('UTF-8','GB2312',urldecode(input('file')));

        if(empty($file) || !file_exists($file)){
            return json(['code'=>0,'msg'=>'文件不存在操作异常，文件名称按要求编辑']);
        }
        $arr=['.PHP','.CSS','.JS','.XML','.TXT','.HTML','.HTACCESS','.HTM','.DOCX','.INI'];
        $exc=strtoupper(substr($file,strripos($file,'.')));
        if (!in_array($exc,$arr)){
            return json(['code'=>0,'msg'=>'该文件类型不支持编辑']);
        }

        if (request()->isPost()){

            $content=input('code');
            //打开要编辑的文件
            $fp=fopen($file,'w');

            //写入新内容
            fwrite($fp,$content);//fputs
            //关闭文件
            fclose($fp);
            return json(['code'=>1,'msg'=>'保存成功']);
        }
        $code=file_get_contents($file);

        View::assign('code',$code);
        View::assign('currfile',$file);
        View::assign('ext',$exc);

        return view();
    }
//    文件下载

    /**
     * @param null $currdir
     */
    public function download($currdir=null){
        $file=urldecode($currdir);
        $file=iconv('UTF-8',"GB2312",$file);
        if(!file_exists($file)){
            $this->error("文件不存在");
        }
        $filename=basenamecn(iconv('GB2312',"UTF-8",$file));
        header('Content-Disposition: attachment;filename='.$filename);
        readfile($file);
    }

    //数据删除

    /**
     * @return \think\response\Json
     */
    public function del(){
        if (request()->isAjax()){
            $file=iconv('UTF-8','GB2312',urldecode(input('file')));
            if (is_dir($file)){
                $arr=scandir($file);
                if (count($arr)===2){
                    @rmdir($file);
                    return json(['msg'=>'目录删除成功']);
                }else{
                    return json(['msg'=>'目录(不为空)删除失败！']);
                }
            }
            if (is_file($file)){
                @unlink($file);
                return json(['msg'=>'文件删除成功']);
            }

            return json(['msg'=>'操作异常']);
        }
    }



    public function file(){
        $dir=input('src');

        move_uploaded_file($_FILES["file"]["tmp_name"], $dir.'/'. $_FILES["file"]["name"]);
        return returnjson(1,"上传成功");
    }

    public function new(){
        $data=input('post.');

        $myfile = fopen($data['file'].'/'.$data['filename'], "w") or die("Unable to open file!");

        fclose($myfile);
        return returnjson(1,"创建完成");
    }

}