<?php
// 应用公共文件
function returnjson($code=1,$msg=""){
    return json(['code'=>$code,'msg'=>$msg]);
};
function create_list($pid, $arr, &$tree = [])
{
    foreach ($arr as $key => $vo) {
        if ($vo['ppid'] == $pid) {
            unset($vo['ppid']);
            $vo['spread']=true;
            $c = create_list($vo['id'], $arr);

            if ($c) {

                $vo['children'] = $c;
            }
            $tree[] = $vo;
        }
    }
    return $tree;
}


/**
 *  post提交数据
 * @param  string $url 请求Url
 * @param  array $datas 提交的数据
 * @return url响应返回的html
 */
function sendPost($url, $datas) {
    $postdata = http_build_query($datas);
    $options = array(
        'http' => array(
            'method' => 'POST',
            'header' => 'Content-type:application/x-www-form-urlencoded',
            'content' => $postdata,
            'timeout' => 15 * 60 // 超时时间（单位:s）
        )
    );
    $context = stream_context_create($options);
    $result = file_get_contents($url, false, $context);
    return $result;
}


function errcode($code){
    switch ($code){
        case "930555":
            $icon="平台系统错误";
            break;
        case "930556":
            $icon="配送公司超时";
            break;
        case "930557":
            $icon="配送公司系统错误";
            break;
        case "930558":
            $icon="配送公司逻辑错误";
            break;
        case "930559":
            $icon="openid无效";
            break;
        case "930560":
            $icon="未绑定的商户号";
            break;
        case "930561":
            $icon="参数错误";
            break;
        case "930562":
            $icon="配送单已经存在";
            break;
        case "930563":
            $icon="配送单不存在";
            break;
        case "930564":
            $icon="调用无配额";
            break;
        case "930565":
            $icon="配送单已结束";
            break;
        case "9300535":
            $icon="shop字段商品缩略图 url、商品名称为空或者非法，或者商品数量为0";
            break;
        default :
            $icon='其他';
    }
    return $icon;
}
function order_status($data){
    switch ($data){
        case "101":
            $icon="等待分配骑手";
            break;
        case "102":
            $icon="分配骑手成功";
            break;
        case "103":
            $icon="商家取消订单， 订单结束";
            break;
        case "201":
            $icon="骑手到店开始取货";
            break;
        case "202":
            $icon="取货成功";
            break;
        case "203":
            $icon="取货失败，商家取消订单， 订单结束";
            break;
        case "204":
            $icon="取货失败，骑手因自身原因取消订单， 订单结束";
            break;
        case "205":
            $icon="取货失败，骑手因商家原因取消订单， 订单结束";
            break;
        case "301":
            $icon="配送中";
            break;
        case "302":
            $icon="配送成功， 订单结束";
            break;
        case "303":
            $icon="商家取消订单，配送物品开始返还商家";
            break;
        case "304":
            $icon="无法联系收货人，配送物品开始返还商家";
            break;
        case "305":
            $icon="收货人拒收，配送物品开始返还商家";
            break;
        case "401":
            $icon="货品返还商户成功， 订单结束";
            break;
        case "501":
            $icon="因运力系统原因取消， 订单结束";
            break;
        case "502":
            $icon="因不可抗拒因素（天气，道路管制等原因）取消，订单结束";
            break;
        default :
            $icon='其他';
    }
    return $icon;
}

function action_type($data){
    switch ($data){
        case "100001":
            $icon="揽件成功";
            break;
        case "100002":
            $icon="揽件失败";
            break;
        case "100003":
            $icon=" 分配业务员";
            break;
        case "200001":
            $icon="运输中";
            break;
        case "300002":
            $icon="开始派送";
            break;
        case "300003":
            $icon="签收成功";
            break;
        case "300004":
            $icon="签收失败";
            break;
        case "400001":
            $icon="订单取消";
            break;
        case "400002":
            $icon="订单滞留";
            break;
        default :
            $icon='运输中';
    }
    return $icon;
}

function gethttp($url){
    $preg = "/^http(s)?:\\/\\/.+/";
    if(preg_match($preg,$url)){
        return true;
    }else{
        return false;
    }
}
function ossimgurl($pic){

        $exc=strtoupper(substr($pic,strrpos($pic,".")));

        if ($exc==".MP4"){
            return $pic.'?x-oss-process=video/snapshot,t_7000,f_jpg,w_160,h_100,m_fast';
        }
        return $pic;
 }